package org.antlr.codegen;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import org.antlr.Tool;
import org.antlr.codegen.CodeGenerator;
import org.antlr.codegen.Target;
import org.antlr.tool.Grammar;
import org.stringtemplate.v4.AttributeRenderer;
import org.stringtemplate.v4.ST;

public class CSharp3Target extends Target {
  private static final HashSet<String> _languageKeywords = (HashSet<String>)new Object();
  
  public boolean useBaseTemplatesForSynPredFragments() {
    return false;
  }
  
  public String encodeIntAsCharEscape(int v) {
    return "\\x" + Integer.toHexString(v).toUpperCase();
  }
  
  public String getTarget64BitStringFromValue(long word) {
    return "0x" + Long.toHexString(word).toUpperCase();
  }
  
  protected void genRecognizerFile(Tool tool, CodeGenerator generator, Grammar grammar, ST outputFileST) throws IOException {
    if (!grammar.getGrammarIsRoot()) {
      Grammar rootGrammar = grammar.composite.getRootGrammar();
      String actionScope = grammar.getDefaultActionScope(grammar.type);
      Map<String, Object> actions = (Map<String, Object>)rootGrammar.getActions().get(actionScope);
      Object rootNamespace = (actions != null) ? actions.get("namespace") : null;
      if (actions != null && rootNamespace != null) {
        actions = (Map<String, Object>)grammar.getActions().get(actionScope);
        if (actions == null) {
          actions = new HashMap<String, Object>();
          grammar.getActions().put(actionScope, actions);
        } 
        actions.put("namespace", rootNamespace);
      } 
    } 
    generator.getTemplates().registerRenderer(String.class, (AttributeRenderer)new StringRenderer(generator, this));
    super.genRecognizerFile(tool, generator, grammar, outputFileST);
  }
}
